package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingMercadoDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingMercado;
import com.rjconsultores.ventaboletos.entidad.Parada;

@Repository("gp_pricingMercadoDAO")
public class GP_PricingMercadoHibernateDAO extends GenericHibernateDAO<GP_PricingMercado, Integer>
		implements GP_PricingMercadoDAO {

	@Autowired
	public GP_PricingMercadoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<GP_PricingMercado> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));

		return c.list();
	}

	public Boolean obtenerPricingMercado(GP_Pricing pricing, Parada origen, Parada destino) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));
		c.add(Restrictions.eq("pricing", pricing));
		c.add(Restrictions.eq("origen", origen));
		c.add(Restrictions.eq("destino", destino));

		if (c.list().size() > 0) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public List<GP_PricingMercado> obtenerTodoPorPricing(GP_Pricing pricing) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("pricing.pricingId", pricing.getPricingId()));

		return c.list();
	}
}
